//=========================================================================
//
//	FILE:				Printing.cpp
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application entry point for printing demo.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:34:48 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================

	// CP_Printing
#include "Printing.h"
#include "Printing_App.h"

	// CPLAT_Framework
#include "CP_Debugging.h"
#include "CP_Exceptions.h"
#include "CP_FrameworkFlags.h"
#include "CP_Startup.h"

#if TARGET_OS_MAC
	#if TARGET_CC_METROWERKS && CP_Debug
		#include <DataViewer.h>
	#endif	// TARGET_CC_METROWERKS && CP_Debug
#endif	// TARGET_OS_MAC

#if TARGET_OS_MAC || TARGET_OS_LINUX
	int main( int argc, char *argv[] )
#else if TARGET_OS_WIN32
	int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow )
#endif
{
	#if TARGET_OS_MAC
		#if TARGET_CC_METROWERKS && CP_Debug
			DataViewLibInit();
		#endif	// TARGET_CC_METROWERKS && CP_Debug
	#endif	// TARGET_OS_MAC

	try
	{	
		#if TARGET_OS_MAC || TARGET_OS_LINUX
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( argc, argv ) );
		#else
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( hInst, hPreInst, lpszCmdLine, nCmdShow  ) );
		#endif
		
		Printing_Application		application;
		application.Run();	
	}
	catch(...)
	{
	}
	
	return( 0 );
}
