//=========================================================================
//
//	FILE:				Printing_View.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			CP_ScrollableView testing pane.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 5 $
//						Latest Checkout:  $Date: 2005-08-30 20:33:00 -0700 (Tue, 30 Aug 2005) $
//
//=========================================================================
#ifndef _H_Printing_View
#define _H_Printing_View
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_View.h"

/*!
*	\class	Printing_View
*	\brief	A pane class of type CP_ScrollableView to test Printing in CPLAT panes.
*/
class CP_EXPORT Printing_View : public CPLAT::CP_View
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										Printing_View(
												CPLAT::CP_View *inSuperview,
												const CPLAT::CP_Point& inUpperLeft,
												const CPLAT::CP_Size& inContentSize );
	//! Destructor.
	virtual								~Printing_View() throw();
	//@}

protected:
	//! @name Drawing
	//@{
	virtual	void						OnDraw(
												CPLAT::CP_Canvas& inCanvas,
												CPLAT::CP_Region& inUpdateArea );
	//@}

	// class data
protected:
	
//========================================================================
// Platform specific routines
//========================================================================
#ifdef TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

#endif	// _H_Printing_View

