//=========================================================================
//
//	FILE:				CP_SignalSlot_Main.cpp
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application entry point for the CP_SignalSlot demo application.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:36:10 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================

	// Precompile header support
#include "CP_Precomp.h"

	// CP_SignalSlot
#include "CP_SignalSlot_Main.h"
#include "CP_SignalSlot_App.h"

	// CPLAT_Framework
#include "CP_Data_ResourceTypes.h"
#include "CP_Exceptions.h"
#include "CP_FrameworkFlags.h"
#include "CP_FrameworkResources.h"
#include "CP_New.h"
#include "CP_Resource.h"
#include "CP_SmartPtr.h"
#include "CP_Startup.h"

#if TARGET_OS_LINUX
	#include "CP_FrameworkStructures_Linux.h"
	#include "CP_Resource_Imp_Linux.h"
	
	extern  void InitLinuxResources();

	extern CPLAT::CP_S_MenuItems_Linux	gMenuBar_Main[];
#endif

#if TARGET_OS_MAC && TARGET_CC_METROWERKS && CP_Debug
	#include <DataViewer.h>
#endif	// TARGET_OS_MAC && TARGET_CC_METROWERKS && CP_Debug

#if TARGET_OS_MAC || TARGET_OS_LINUX
	int main( int argc, char *argv[] )
#else if TARGET_OS_WIN32
	int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow )
#endif
{
	#if TARGET_OS_MAC && TARGET_CC_METROWERKS && CP_Debug
		DataViewLibInit();
	#endif	// TARGET_OS_MAC && TARGET_CC_METROWERKS && CP_Debug

	try
	{	
		#if TARGET_OS_LINUX
			InitLinuxResources();
		#endif

		#if TARGET_OS_MAC || TARGET_OS_LINUX
			CPLAT::CP_Startup 			platformStartup( argc, argv );
		#else
			CPLAT::CP_Startup 			platformStartup( hInst, hPreInst, lpszCmdLine, nCmdShow );
		#endif
	
		CP_SignalSlot_Application		application;
		application.Run();	
	}
	catch(...)
	{
	}
	
	return( 0 );
}

#if TARGET_OS_LINUX
		// Initialize the resources used in the Linux build
	void InitLinuxResources()
	{
		CPLAT::FourCharCode			resType = CPLAT::kMenuBarResourceType;
		SInt16						resID = CPLAT::kCP_DefaultMenuBarID;
		CPLAT::OSHandle				resourceData = (CPLAT::OSHandle) &gMenuBar_Main;

		CP_ADD_RESOURCE_ENTRY( resType, resID, resourceData );
	}
#endif	// TARGET_OS_LINUX
