//=========================================================================
//
//	FILE:				CP_COM.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Definitions and classes for dealing with COM interfaces.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_COM
#define _H_CP_COM
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_ResourcePtr.h"

#if TARGET_OS_MAC	
		// COM defines
	#if __CF_USE_FRAMEWORK_INCLUDES__
		#include <CoreFoundation/CFPlugInCOM.h>
	#else
		#include "CFPlugInCOM.h"
	#endif
#endif

CPLAT_Begin_Namespace_CPLAT

namespace CP_COM
{

#if TARGET_OS_MAC
	#if ! IUnknown
		#define IUnknown		IUnknownVTbl
	#endif
#endif

#if TARGET_OS_MAC

class CP_GUID : public CP_ResourcePtr<CFUUIDRef>
{
public:
	explicit							CP_GUID(
												CFUUIDRef inRef,
												bool inFromCopyOrCreate );
	explicit							CP_GUID(
												UInt8 byte0,
												UInt8 byte1,
												UInt8 byte2,
												UInt8 byte3,
												UInt8 byte4,
												UInt8 byte5,
												UInt8 byte6,
												UInt8 byte7,
												UInt8 byte8,
												UInt8 byte9,
												UInt8 byte10,
												UInt8 byte11,
												UInt8 byte12,
												UInt8 byte13,
												UInt8 byte14,
												UInt8 byte15 );
	
										operator CFUUIDBytes () const;
};

typedef CP_GUID		IID;

extern const IID	IID_IUnknown;

bool	CP_IsEqualIID( REFIID inRefIID1, REFIID inRefIID2 ) throw();
bool	operator == ( REFIID inRefIID1, REFIID inRefIID2 );
bool	operator != ( REFIID inRefIID1, REFIID inRefIID2 );

#endif	// TARGET_OS_MAC

}	// namespace CP_COM

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_COM

