//=========================================================================
//
//	FILE:				CP_NetworkAddress.h
//	
//						Created by Jens Miltner on 01.12.04.
//	
//	PURPOSE:			Class to handle network addresses.
//	
//	HISTORY:			1st Version - January 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 123 $
//						Latest Checkout:  $Date: 2005-03-25 19:52:48 -0800 (Fri, 25 Mar 2005) $
//
//=========================================================================
#ifndef _H_CP_NetworkAddress
#define _H_CP_NetworkAddress
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_String.h"

CPLAT_Begin_Namespace_CPLAT

class CP_NetworkAddress
{
public:
	enum AddressType
	{
		IPv4=0,
		IPv6
	};

	static const CP_NetworkAddress		null;

	CP_NetworkAddress(void);
	CP_NetworkAddress(UInt32 inIPAddress);
	CP_NetworkAddress(const CP_String& inIPAddress);
	UInt32	GetIPv4Address(void) const;
	AddressType	GetAddressType(void) const {return fAddressType;}
	CP_String AsString(void) const;

	bool operator < (const CP_NetworkAddress& inRhs) const;
	bool operator <= (const CP_NetworkAddress& inRhs) const;
	bool operator > (const CP_NetworkAddress& inRhs) const;
	bool operator >= (const CP_NetworkAddress& inRhs) const;
	bool operator == (const CP_NetworkAddress& inRhs) const;
	bool operator != (const CP_NetworkAddress& inRhs) const;
	CP_NetworkAddress operator & (const CP_NetworkAddress& inRhs) const;
	
protected:
	UInt32					fIPAddress_v4;
	AddressType			fAddressType;
};

CPLAT_End_Namespace_CPLAT

#endif // _H_CP_NetworkAddress