//=========================================================================
//
//	FILE:				CP_Structure_Defines.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Defifnes for some structures used in CPLAT.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 140 $
//						Latest Checkout:  $Date: 2005-04-09 22:02:13 -0700 (Sat, 09 Apr 2005) $
//
//=========================================================================
#ifndef _H_CP_Structure_Defines
#define _H_CP_Structure_Defines
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_EditField.h"
#include "CP_PlatformControl.h"
#include "CP_Types.h"
#include "CP_View.h"

CPLAT_Begin_Namespace_CPLAT

	// type of content used in a control (used for buttons, and views that display images/text)
typedef SInt16 CP_View_ContentType;

struct CP_S_ViewContentInfo
{
	CP_View_ContentType  			fContentType;
	
	union
	{
		SInt16             		 	fResourceID;
		
			// type of image
		OSIconRef					fIconRef;
		OSIconSuite					fIconSuite;
		OSHandle					fICON;
		OSPicture					fPicture;
		OSColorIcon					fCIconHandle;
	} u;
};

	// item sent in the kCP_Signal_Clicked signal when the user clicked a control
struct CP_S_ControlClickedInfo
{
	UInt32  						fCommand;
	SInt32  						fValue;
	CP_View							*fSendingControl;
};

	// item sent in the kCP_Signal_ColumnResizing signal when the user causes some view or
	// control to resize one of its columns.
struct CP_S_ColumnResizedInfo
{
	SInt32  						fResizingColumn;		/* column being resized */
	SInt32							fDelta;					/* amount column width has changed */
	CP_View							*fSendingView;			/* Originating view that column is being resized */
};

	// item sent in the kCP_Signal_ColumnSort signal when the user causes some view or
	// control to need to sort some data.
struct CP_S_ColumnSortInfo
{
	SInt32  						fSortColumn;			/* column to sort */
	SInt32							fSortDirectionUp;		/* direction of sort */
	CP_View							*fSendingView;			/* Originating view that column is being resized */
};

struct CP_S_DragDropData
{
	FourCharCode					fFlavorType;
	CP_DataStream					*fDataStream;
};

#define kCPLAT_MenuDataCreator				CP_FOUR_CHAR_CODE('CPLA')
#define kCPLAT_ControlMenuDataType			CP_FOUR_CHAR_CODE('CTLM')

struct CP_S_MenuData_Control
{
	FourCharCode					fMenuDataType;
	CP_PlatformControl				*fSendingControl;
};

struct CP_S_FieldExit
{
	char							fChar;
	UInt32							fModifiers;
	CP_EditField					*fEditField;
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Structure_Defines

