//=========================================================================
//
//	FILE:				CP_ViewCont_Imp_Gtk2Widget.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Implementation of a custom GtkWidget to provide a container
//						that contains other CP_Views, but does not draw, and
//						provides a neutral background. This class is
//						used with Gtk2.x.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_ViewCont_Imp_Gtk2Widget
#define _H_CP_ViewCont_Imp_Gtk2Widget
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_View_Imp_Gtk.h"

CPLAT_Begin_Namespace_CPLAT

#if TARGET_OS_LINUX && TARGET_API_GTK2

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_CP_VIEW_CONTAINER						(CP_View_GtkWidgetContainer_get_type())
#define CP_VIEW_GTK_WIDGET_CONTAINER(obj)				(G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_CP_VIEW_CONTAINER, GtkCPViewContainer))
#define CP_VIEW_GTK_WIDGET_CONTAINER_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), GTK_TYPE_CP_VIEW_CONTAINER, GtkCPViewContainerClass))
#define GTK_IS_CP_VIEW_CONTAINER(obj)					(G_TYPE_CHECK_INSTANCE_TYPE((obj), GTK_TYPE_CP_VIEW_CONTAINER))
#define GTK_IS_CP_VIEW_CONTAINER_CLASS(klass)			(G_TYPE_CHECK_CLASS_TYPE((klass), GTK_TYPE_CP_VIEW_CONTAINER))
#define CP_VIEW_GTK_WIDGET_CONTAINER_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS((obj), GTK_TYPE_CP_VIEW_CONTAINER, GtkCPViewContainerClass))


typedef struct _GtkCPViewContainer			GtkCPViewContainer;
typedef struct _GtkCPViewContainerClass		GtkCPViewContainerClass;

struct _GtkCPViewContainer
{
	GtkBin			bin;
	GtkAllocation	child_allocation;
};

struct _GtkCPViewContainerClass
{
	GtkBinClass		parent_class;

	void (*compute_child_allocation)( GtkCPViewContainer *viewContainer, GtkAllocation *allocation );
};

GType		CP_View_GtkWidgetContainer_get_type(void) G_GNUC_CONST;
GtkWidget	*CP_View_GtkWidgetContainer_new();

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// TARGET_OS_LINUX && TARGET_API_GTK2

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_ViewCont_Imp_Gtk2Widget

