//=========================================================================
//
//	FILE:				CP_View_Imp_Gtk2Widget.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Implementation of a custom GtkWidget to provide the
//						features for the CP_View_Imp_Gtk class. This class is
//						used with Gtk2.x.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_View_Imp_Gtk2Widget
#define _H_CP_View_Imp_Gtk2Widget
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_View_Imp_Gtk.h"

CPLAT_Begin_Namespace_CPLAT

#if TARGET_OS_LINUX && TARGET_API_GTK2

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define CP_GTK2_WIDGET(obj)				GTK_CHECK_CAST( obj, CP_Gtk2_Widget_get_type(), CP_View_Gtk2Widget )
#define CP_GTK2_WIDGET_CLASS(klass)		GTK_CHECK_CLASS_CAST( klass, CP_Gtk2_Widget_get_type (), CP_View_Gtk2WidgetClass )
#define IS_CP_GTK2_WIDGET(obj)			GTK_CHECK_TYPE( obj, CP_Gtk2_Widget_get_type() )


typedef struct _CP_View_Gtk2Widget        CP_View_Gtk2Widget;
typedef struct _CP_View_Gtk2WidgetClass   CP_View_Gtk2WidgetClass;

struct _CP_View_Gtk2Widget
{
  GtkWidget widget;

	CP_View_Imp_Gtk		*fOwnerViewImp;
};

struct _CP_View_Gtk2WidgetClass
{
	GtkWidgetClass		parent_class;
};

GtkWidget		*CP_Gtk2_Widget_new( CP_View_Imp_Gtk *inDestView );
guint			CP_Gtk2_Widget_get_type(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// TARGET_OS_LINUX && TARGET_API_GTK2

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_View_Imp_Gtk2Widget

