//=========================================================================
//
//	FILE:				CP_WndProcs.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Callbacks from Windows windows to our CPLAT classes.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_WndProcs
#define _H_CP_WndProcs
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_WIN32

	// CPLAT_Framework

CPLAT_Begin_Namespace_CPLAT

//!  CP_WndProcs
/*!
  Callbacks from Windows child windows to our CPLAT classes.
*/

/*!
  Callback used for CP_View_Imp Windows implementation.
*/
LRESULT CALLBACK	ViewWndProc(
							HWND hwnd,
							UINT iMsg,
							WPARAM wParam,
							LPARAM inLParam );

LRESULT CALLBACK	ViewHelperWndProc(
							HWND hwnd,
							UINT iMsg,
							WPARAM wParam,
							LPARAM inLParam );


/*!
  Callback used for CP_Window_Imp Windows implementation.
*/
LRESULT CALLBACK	WindowWndProc(
							HWND hwnd,
							UINT iMsg,
							WPARAM wParam,
							LPARAM inLParam );


/*!
  Callback used for MDI child Windows implementation.
*/
LRESULT CALLBACK	WindowMDIChildWndProc(
							HWND hwnd,
							UINT iMsg,
							WPARAM wParam,
							LPARAM inLParam );
							
CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_WIN32

#endif	// _H_CP_WndProcs

