//=========================================================================
//
//	FILE:				CP_NonDebug_win.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Header file to create a precompiled header for CPLAT
//						projects.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	PLATFORM:			Windows
//	DEBUGGING:			Debug
//
//	VERSION:			Current Revision: $Rev: 106 $
//						Latest Checkout:  $Date: 2005-03-21 15:03:06 -0800 (Mon, 21 Mar 2005) $
//
//=========================================================================

// ===================================================================================
//	Platform build flags
// ===================================================================================
#define TARGET_OS_MAC						0
#define TARGET_API_MAC_CARBON				0

#define TARGET_OS_WIN32						1

#define TARGET_OS_LINUX						0

// ===================================================================================
//	Debugging flags
// ===================================================================================
#define CP_Debug							0
#define CP_Debug_Exceptions					0
#define CP_Debug_RecordMemoryAllocations	0
#define CP_Debug_UseCustomOperatorNew		0
#define CP_Debug_RecordOSCalls				0
#define CP_Debug_RecordMemoryAllocations	0

	// WinSDK
#define _DEBUG								CP_Debug

// ===================================================================================
//	OS Environment
// ===================================================================================
#define STRICT								1
#define UNICODE								1
	
// ===================================================================================
//	Optional flags
// ===================================================================================
#define CP_Optional_GDIPlus					1		// Default is to use GDI+

// ===================================================================================
//	Namespace
// ===================================================================================
#define ENABLE_STD_NAMESPACE				1		// disable std namespace
	
// ===================================================================================
//	MSL Defines
// ===================================================================================
#if TARGET_CC_METROWERKS
	#include <ansi_prefix.win32.h>
#endif

#ifndef __dest_os
	#define __dest_os					__win32_os
#endif

// ===================================================================================
//	Window SDK includes
// ===================================================================================
#include <winsock2.h>
#include <windows.h>
#include <tchar.h>

#undef min
#undef max

// ===================================================================================
//	CPLAT_Framework includes
// ===================================================================================
#include "CP_Types.h"
#include "CP_FrameworkFlags.h"

#include "UserPrefixFlags.h"

#include "CP_FrameworkHeaders.h"
